import FileButton from '@/components/FileViewRedirectButton/FileButton'
import type { EmailDetails } from '@inject/graphql/fragments/EmailDetails.generated'
import type { FC } from 'react'

interface EmailContentProps {
  details: EmailDetails
  teamId: string
  exerciseId: string
  inInstructor: boolean
  allowFileRedirect: boolean
}

const EmailContent: FC<EmailContentProps> = ({
  details,
  teamId,
  exerciseId,
  inInstructor,
  allowFileRedirect,
}) => (
  <>
    <div
      dangerouslySetInnerHTML={{
        __html: details.content.rendered,
      }}
    />
    {details.content.fileInfo && (
      <div
        style={{
          marginTop: details.content.rendered ? '10px' : undefined,
        }}
      >
        <FileButton
          teamId={teamId}
          fileInfo={details.content.fileInfo}
          exerciseId={exerciseId}
          inInstructor={inInstructor}
          allowRedirect={allowFileRedirect}
        />
      </div>
    )}
  </>
)

export default EmailContent
