import type { FC } from 'react'
import { HIGHLIGHTED_COLOR } from '../utilities'

interface LabelProps {
  text: string
}

const Label: FC<LabelProps> = ({ text }) => (
  <span
    style={{
      backgroundColor: HIGHLIGHTED_COLOR,
      lineHeight: '30px',
      padding: '0 5px 0 8px',
      borderRadius: '2px',
      flexGrow: 1,
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis',
    }}
    title={text}
  >
    {text}
  </span>
)

export default Label
