import { Button, Section } from '@blueprintjs/core'
import { useAuthIdentity } from '@inject/graphql/auth'
import { useNavigate } from 'react-router-dom'

const GraphiQL = () => {
  const nav = useNavigate()
  const { isSuperuser } = useAuthIdentity(!!window.INJECT_NOAUTH)

  return isSuperuser ? (
    <Section
      title={'GraphiQL interface'}
      subtitle={'Explore the GraphQL API with GraphiQL'}
      rightElement={
        <Button onClick={() => nav('/graphiql')}>Open GraphiQL</Button>
      }
    />
  ) : (
    <></>
  )
}

export default GraphiQL
