import { Section, Switch } from '@blueprintjs/core'
import { relativeTime, useRelativeTime } from '../vars/relativeTime'

const RelativeTime = () => {
  const View = () => {
    const relativeTimeVar = useRelativeTime()
    return (
      <>
        <span>{relativeTimeVar ? 'Relative time' : 'Absolute time'}</span>
        <Switch
          style={{ margin: '0' }}
          checked={relativeTimeVar}
          onChange={() => relativeTime(!relativeTimeVar)}
        />
      </>
    )
  }
  return (
    <Section
      title={'Relative Time'}
      subtitle={
        'Change the representation of time in analyst view, either relatively or absolutely.'
      }
      rightElement={
        <div style={{ display: 'flex', gap: '0.25rem', alignItems: 'center' }}>
          <View />
        </div>
      }
    />
  )
}

export default RelativeTime
