import { useNavigate } from '@/router'
import type { ButtonProps } from '@blueprintjs/core'
import { Button } from '@blueprintjs/core'
import type { FC } from 'react'

export type LinkType = Parameters<ReturnType<typeof useNavigate>>

export interface LinkButtonProps {
  link: LinkType
  button: ButtonProps
}

const LinkButton: FC<LinkButtonProps> = ({ link, button }) => {
  const nav = useNavigate()

  return (
    <Button
      {...button}
      onClick={event => {
        button.onClick?.(event)

        // prefer-spread is broken in TS, so we have to use apply
        // eslint-disable-next-line prefer-spread
        nav.apply(null, link)
      }}
    />
  )
}

export default LinkButton
