import { Button } from '@blueprintjs/core'
import { useState } from 'react'

const useHideButton = () => {
  const [hide, setHide] = useState(false)

  return {
    hide,
    setHide,
    node: (
      <Button
        icon={hide ? 'menu-open' : 'menu-closed'}
        alignText='left'
        fill
        minimal
        text={!hide && 'Hide sidebar'}
        onClick={() => setHide(prev => !prev)}
        style={{ whiteSpace: 'nowrap' }}
        title={`${hide ? 'Show' : 'Hide'} sidebar`}
      />
    ),
  }
}

export default useHideButton
