import type { Path } from '@/router'
import { useNavigate } from '@/router'
import { Button } from '@blueprintjs/core'
import type { FC } from 'react'

interface NavbarButtonProps {
  path: Path
  name: string
}

const NavbarButton: FC<NavbarButtonProps> = ({ path, name }) => {
  const nav = useNavigate()

  return (
    <Button type='button' onClick={() => nav(path)} alignText='left' minimal>
      {name}
    </Button>
  )
}

export default NavbarButton
