import type { EmailAddress } from '@inject/graphql/fragments/EmailAddress.generated'
import type { LearningObjective } from '@inject/graphql/fragments/LearningObjective.generated'

export enum LearningActivityType {
  CONFIRMATION = 'Confirmation',
  TOOL = 'Tool',
  EMAIL = 'Email',
}

export enum InjectType {
  INFORMATION = 'Information',
  EMAIL = 'Email',
}

export type LearningObjectiveInfo = Pick<LearningObjective, 'id' | 'name'>

export type LearningActivityInfo = {
  id: number
  name: string
  description: string
  type: LearningActivityType
  learningObjectiveId: string
}

export type InjectInfo = {
  id: number
  name: string
  description: string
  type: InjectType
}

export type ToolInfo = {
  id: number
  name: string
  category: string
  tooltipDescription: string
  defaultResponse: string
  hint: string
}

export type ToolResponse = {
  id: number
  learningActivityId: number
  toolId: number
  parameter: string
  isRegex: boolean
  content: string
}

export type EmailAddressInfo = Omit<EmailAddress, 'control'>

export type EmailTemplate = {
  id: number
  learningActivityId: number
  emailAddressId: number
  context: string
  content: string
}
