import { useModals } from '@/router'
import { Button, ButtonGroup, Section, SectionCard } from '@blueprintjs/core'
import { useGetExercises } from '@inject/graphql/queries/GetExercises.generated'
import ExerciseList from './components/ExerciseList'

const ExerciseManager = () => {
  const { refetch } = useGetExercises({
    fetchPolicy: 'standby',
  })
  const { open } = useModals()

  return (
    <Section
      title='Exercises'
      rightElement={
        <ButtonGroup onClick={e => e.stopPropagation()}>
          <Button
            onClick={() => {
              open('/instructor/exerciseCreator')
            }}
            icon='plus'
          >
            Add
          </Button>
          <Button
            type='button'
            onClick={e => {
              e.preventDefault()
              e.stopPropagation()
              refetch()
            }}
            icon='reset'
          >
            Reload
          </Button>
        </ButtonGroup>
      }
      collapsible
    >
      <SectionCard>
        <ExerciseList />
      </SectionCard>
    </Section>
  )
}

export default ExerciseManager
