import GitVersion from '@/components/GitVersion'
import DefinitionManager from '@/exercisepanel/DefinitionManager'
import ExerciseManager from '@/exercisepanel/ExerciseManager'
import { useSetPageTitle } from '@/utils'
import { css } from '@emotion/css'
import { Modals } from '@generouted/react-router'
import Container from '@inject/shared/components/Container'

const wrapper = css`
  padding: 1rem 0;
  display: flex;
  flex-direction: column;
  gap: 1rem;
`

const ExercisePanel = () => {
  useSetPageTitle('Exercise Panel')

  return (
    <>
      <Container>
        <div className={wrapper}>
          <DefinitionManager />
          <ExerciseManager />
          <GitVersion />
        </div>
      </Container>

      {/* needed for the DefinitionManager, as it uses a modal path */}
      <Modals />
    </>
  )
}

export default ExercisePanel
