import ColorMode from '@/clientsettings/components/ColorMode'
import Connection from '@/clientsettings/components/Connection'
import GraphiQL from '@/clientsettings/components/GraphiQL'
import InstructorTeams from '@/clientsettings/components/InstructorTeams'
import Logout from '@/clientsettings/components/Logout'
import Notification from '@/clientsettings/components/Notification'
import RelativeTime from '@/clientsettings/components/RelativeTime'
import { useSetPageTitle } from '@/utils'
import { css } from '@emotion/css'
import { useAuthIdentity } from '@inject/graphql/auth'
import Container from '@inject/shared/components/Container'

const heading = css`
  margin: 1rem 0 0.5rem 0;
`

const Settings = () => {
  useSetPageTitle('Settings')
  const { isStaff, isSuperuser } = useAuthIdentity(!!window.INJECT_NOAUTH)

  return (
    <Container>
      <h2 className={heading}>Settings</h2>
      <Notification />
      <ColorMode />
      {!window.INJECT_NOAUTH && <Logout />}
      <Connection />
      {isSuperuser && !window.INJECT_NOAUTH && <GraphiQL />}
      {isStaff && (
        <>
          <h2 className={heading}>Instructor</h2>
          <InstructorTeams />
          <h2 className={heading}>Analyst</h2>
          <RelativeTime />
        </>
      )}
    </Container>
  )
}

export default Settings
