import { useNavigate } from '@/router'
import UserTable from '@/users/UserTable'
import { useSetPageTitle } from '@/utils'

const UserManagementIndexPage = () => {
  useSetPageTitle('User management')
  const nav = useNavigate()

  return (
    <UserTable
      onClick={(userId: string) =>
        nav('/users/:userId', {
          params: { userId },
        })
      }
    />
  )
}

export default UserManagementIndexPage
