import { useParams } from '@/router'
import { useSetPageTitle, useStaffBoundary } from '@/utils'
import InstructorView from '@/views/InstructorView'
import { Outlet } from 'react-router-dom'

const Layout = () => {
  const { exerciseId, teamId } = useParams('/instructor/:exerciseId/:teamId')
  useStaffBoundary()
  useSetPageTitle('Instructor')

  return (
    <InstructorView exerciseId={exerciseId} teamId={teamId}>
      <Outlet />
    </InstructorView>
  )
}

export default Layout
