import type { FC } from 'react'
import { detailRow, detailRowName } from '.'
import type { UserValueType } from '../UserTable'
import { formatValue } from '../utilities'

interface UserDetailRowProps {
  name: string
  value: UserValueType
}

const UserDetailRow: FC<UserDetailRowProps> = ({ name, value }) => (
  <div className={detailRow}>
    <span className={detailRowName}>{name}: </span> {formatValue(value)}
  </div>
)

export default UserDetailRow
