import { formatTimestamp } from '@/analyst/utilities'
import type { UserValueType } from './UserTable'

export const accountStatuses = ['yes', 'no']

export const accountStatusesOptions = [
  { label: 'yes', value: 'true' },
  { label: 'no', value: 'false' },
]

export const formatValue = (value: UserValueType) => {
  if (typeof value === 'string') return value
  if (typeof value === 'boolean') return value ? 'yes' : 'no'
  if (value instanceof Date) return formatTimestamp(value.toISOString())
  return (value as UserValueType)?.toString() || ''
}
