import { Button } from '@blueprintjs/core'
import { useState } from 'react'

const useMilestonesButton = ({
  hideLabel,
  disabled,
}: {
  hideLabel: boolean
  disabled: boolean
}) => {
  const [open, setOpen] = useState(false)

  return {
    open,
    setOpen,
    node: (
      <Button
        active={open}
        disabled={disabled}
        icon='flag'
        alignText='left'
        fill
        minimal
        text={!hideLabel && 'Milestones'}
        onClick={() => setOpen(prev => !prev)}
        title='Milestones'
      />
    ),
  }
}

export default useMilestonesButton
