/* eslint-disable */
//@ts-nocheck
import type * as _Types from '../../types';

import type { DocumentNode } from 'graphql';
import * as Apollo from '@apollo/client';
const defaultOptions = {} as const;
export type WriteEmailDraftVariables = _Types.Exact<{
  emailDraft: _Types.EmailDraftInput;
}>;


export type WriteEmailDraft = { writeEmailDraft: { teamId: string, instructor: boolean, emailThreadId: string | null, senderAddress: string | null, content: string | null, activateMilestone: string | null, deactivateMilestone: string | null, fileId: any | null, selectedContacts: Array<string | null> | null, subject: string | null, templateId: string | null } | null };


export const WriteEmailDraftDocument = /*#__PURE__*/ {"kind":"Document","definitions":[{"kind":"OperationDefinition","operation":"mutation","name":{"kind":"Name","value":"WriteEmailDraft"},"variableDefinitions":[{"kind":"VariableDefinition","variable":{"kind":"Variable","name":{"kind":"Name","value":"emailDraft"}},"type":{"kind":"NonNullType","type":{"kind":"NamedType","name":{"kind":"Name","value":"EmailDraftInput"}}}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"writeEmailDraft"},"arguments":[{"kind":"Argument","name":{"kind":"Name","value":"emailDraft"},"value":{"kind":"Variable","name":{"kind":"Name","value":"emailDraft"}}}],"directives":[{"kind":"Directive","name":{"kind":"Name","value":"client"}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"EmailDraft"}}]}}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"EmailDraft"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"EmailDraftType"}},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"teamId"}},{"kind":"Field","name":{"kind":"Name","value":"instructor"}},{"kind":"Field","name":{"kind":"Name","value":"emailThreadId"}},{"kind":"Field","name":{"kind":"Name","value":"senderAddress"}},{"kind":"Field","name":{"kind":"Name","value":"content"}},{"kind":"Field","name":{"kind":"Name","value":"activateMilestone"}},{"kind":"Field","name":{"kind":"Name","value":"deactivateMilestone"}},{"kind":"Field","name":{"kind":"Name","value":"fileId"}},{"kind":"Field","name":{"kind":"Name","value":"selectedContacts"}},{"kind":"Field","name":{"kind":"Name","value":"subject"}},{"kind":"Field","name":{"kind":"Name","value":"templateId"}}]}}]} as unknown as DocumentNode;
export type WriteEmailDraftMutationFn = Apollo.MutationFunction<WriteEmailDraft, WriteEmailDraftVariables>;

/**
 * __useWriteEmailDraft__
 *
 * To run a mutation, you first call `useWriteEmailDraft` within a React component and pass it any options that fit your needs.
 * When your component renders, `useWriteEmailDraft` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [writeEmailDraft, { data, loading, error }] = useWriteEmailDraft({
 *   variables: {
 *      emailDraft: // value for 'emailDraft'
 *   },
 * });
 */
export function useWriteEmailDraft(baseOptions?: Apollo.MutationHookOptions<WriteEmailDraft, WriteEmailDraftVariables>) {
        const options = {...defaultOptions, ...baseOptions}
        return Apollo.useMutation<WriteEmailDraft, WriteEmailDraftVariables>(WriteEmailDraftDocument, options);
      }
export type WriteEmailDraftHookResult = ReturnType<typeof useWriteEmailDraft>;
export type WriteEmailDraftMutationResult = Apollo.MutationResult<WriteEmailDraft>;
export type WriteEmailDraftMutationOptions = Apollo.BaseMutationOptions<WriteEmailDraft, WriteEmailDraftVariables>;