/* eslint-disable */
//@ts-nocheck
import type * as _Types from '../types';

import type { DocumentNode } from 'graphql';
import * as Apollo from '@apollo/client';
const defaultOptions = {} as const;
export type GetExtendedTeamToolsVariables = _Types.Exact<{
  teamId: _Types.Scalars['ID']['input'];
}>;


export type GetExtendedTeamTools = { extendedTeamTools: Array<{ id: string, name: string, tooltipDescription: string, defaultResponse: string, roles: string, hint: string, hasParam: boolean | null, definition: { id: number | null, name: string | null } | null, responses: Array<{ id: string, param: string }> } | null> | null };


export const GetExtendedTeamToolsDocument = /*#__PURE__*/ {"kind":"Document","definitions":[{"kind":"OperationDefinition","operation":"query","name":{"kind":"Name","value":"GetExtendedTeamTools"},"variableDefinitions":[{"kind":"VariableDefinition","variable":{"kind":"Variable","name":{"kind":"Name","value":"teamId"}},"type":{"kind":"NonNullType","type":{"kind":"NamedType","name":{"kind":"Name","value":"ID"}}}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"extendedTeamTools"},"arguments":[{"kind":"Argument","name":{"kind":"Name","value":"teamId"},"value":{"kind":"Variable","name":{"kind":"Name","value":"teamId"}}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"ExtendedTool"}}]}}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"ExtendedTool"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"ExtendedToolType"}},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"id"}},{"kind":"Field","name":{"kind":"Name","value":"name"}},{"kind":"Field","name":{"kind":"Name","value":"tooltipDescription"}},{"kind":"Field","name":{"kind":"Name","value":"defaultResponse"}},{"kind":"Field","name":{"kind":"Name","value":"roles"}},{"kind":"Field","name":{"kind":"Name","value":"hint"}},{"kind":"Field","name":{"kind":"Name","value":"definition"},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"ExerciseDefinition"}}]}},{"kind":"Field","name":{"kind":"Name","value":"responses"},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"ToolResponse"}}]}},{"kind":"Field","name":{"kind":"Name","value":"hasParam"},"directives":[{"kind":"Directive","name":{"kind":"Name","value":"client"}}]}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"ExerciseDefinition"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"ExerciseDefinitionType"}},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"id"}},{"kind":"Field","name":{"kind":"Name","value":"name"}}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"ToolResponse"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"ToolResponseType"}},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"id"}},{"kind":"Field","name":{"kind":"Name","value":"param"}}]}}]} as unknown as DocumentNode;

/**
 * __useGetExtendedTeamTools__
 *
 * To run a query within a React component, call `useGetExtendedTeamTools` and pass it any options that fit your needs.
 * When your component renders, `useGetExtendedTeamTools` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useGetExtendedTeamTools({
 *   variables: {
 *      teamId: // value for 'teamId'
 *   },
 * });
 */
export function useGetExtendedTeamTools(baseOptions: Apollo.QueryHookOptions<GetExtendedTeamTools, GetExtendedTeamToolsVariables> & ({ variables: GetExtendedTeamToolsVariables; skip?: boolean; } | { skip: boolean; }) ) {
        const options = {...defaultOptions, ...baseOptions}
        return Apollo.useQuery<GetExtendedTeamTools, GetExtendedTeamToolsVariables>(GetExtendedTeamToolsDocument, options);
      }
export function useGetExtendedTeamToolsLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<GetExtendedTeamTools, GetExtendedTeamToolsVariables>) {
          const options = {...defaultOptions, ...baseOptions}
          return Apollo.useLazyQuery<GetExtendedTeamTools, GetExtendedTeamToolsVariables>(GetExtendedTeamToolsDocument, options);
        }
export function useGetExtendedTeamToolsSuspenseQuery(baseOptions?: Apollo.SuspenseQueryHookOptions<GetExtendedTeamTools, GetExtendedTeamToolsVariables>) {
          const options = {...defaultOptions, ...baseOptions}
          return Apollo.useSuspenseQuery<GetExtendedTeamTools, GetExtendedTeamToolsVariables>(GetExtendedTeamToolsDocument, options);
        }
export type GetExtendedTeamToolsHookResult = ReturnType<typeof useGetExtendedTeamTools>;
export type GetExtendedTeamToolsLazyQueryHookResult = ReturnType<typeof useGetExtendedTeamToolsLazyQuery>;
export type GetExtendedTeamToolsSuspenseQueryHookResult = ReturnType<typeof useGetExtendedTeamToolsSuspenseQuery>;
export type GetExtendedTeamToolsQueryResult = Apollo.QueryResult<GetExtendedTeamTools, GetExtendedTeamToolsVariables>;