/* eslint-disable */
//@ts-nocheck
import type * as _Types from '../../types';

import type { DocumentNode } from 'graphql';
import * as Apollo from '@apollo/client';
const defaultOptions = {} as const;
export type ReturnLocalEmailDraftVariables = _Types.Exact<{
  teamId: _Types.Scalars['ID']['input'];
  instructor: _Types.Scalars['Boolean']['input'];
  emailThreadId: _Types.InputMaybe<_Types.Scalars['ID']['input']>;
}>;


export type ReturnLocalEmailDraft = { returnLocalEmailDraft: { teamId: string, instructor: boolean, emailThreadId: string | null, senderAddress: string | null, content: string | null, activateMilestone: string | null, deactivateMilestone: string | null, fileId: any | null, selectedContacts: Array<string | null> | null, subject: string | null, templateId: string | null } | null };


export const ReturnLocalEmailDraftDocument = /*#__PURE__*/ {"kind":"Document","definitions":[{"kind":"OperationDefinition","operation":"query","name":{"kind":"Name","value":"ReturnLocalEmailDraft"},"variableDefinitions":[{"kind":"VariableDefinition","variable":{"kind":"Variable","name":{"kind":"Name","value":"teamId"}},"type":{"kind":"NonNullType","type":{"kind":"NamedType","name":{"kind":"Name","value":"ID"}}}},{"kind":"VariableDefinition","variable":{"kind":"Variable","name":{"kind":"Name","value":"instructor"}},"type":{"kind":"NonNullType","type":{"kind":"NamedType","name":{"kind":"Name","value":"Boolean"}}}},{"kind":"VariableDefinition","variable":{"kind":"Variable","name":{"kind":"Name","value":"emailThreadId"}},"type":{"kind":"NamedType","name":{"kind":"Name","value":"ID"}}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"returnLocalEmailDraft"},"arguments":[{"kind":"Argument","name":{"kind":"Name","value":"teamId"},"value":{"kind":"Variable","name":{"kind":"Name","value":"teamId"}}},{"kind":"Argument","name":{"kind":"Name","value":"instructor"},"value":{"kind":"Variable","name":{"kind":"Name","value":"instructor"}}},{"kind":"Argument","name":{"kind":"Name","value":"emailThreadId"},"value":{"kind":"Variable","name":{"kind":"Name","value":"emailThreadId"}}}],"directives":[{"kind":"Directive","name":{"kind":"Name","value":"client"}}],"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"FragmentSpread","name":{"kind":"Name","value":"EmailDraft"}}]}}]}},{"kind":"FragmentDefinition","name":{"kind":"Name","value":"EmailDraft"},"typeCondition":{"kind":"NamedType","name":{"kind":"Name","value":"EmailDraftType"}},"selectionSet":{"kind":"SelectionSet","selections":[{"kind":"Field","name":{"kind":"Name","value":"teamId"}},{"kind":"Field","name":{"kind":"Name","value":"instructor"}},{"kind":"Field","name":{"kind":"Name","value":"emailThreadId"}},{"kind":"Field","name":{"kind":"Name","value":"senderAddress"}},{"kind":"Field","name":{"kind":"Name","value":"content"}},{"kind":"Field","name":{"kind":"Name","value":"activateMilestone"}},{"kind":"Field","name":{"kind":"Name","value":"deactivateMilestone"}},{"kind":"Field","name":{"kind":"Name","value":"fileId"}},{"kind":"Field","name":{"kind":"Name","value":"selectedContacts"}},{"kind":"Field","name":{"kind":"Name","value":"subject"}},{"kind":"Field","name":{"kind":"Name","value":"templateId"}}]}}]} as unknown as DocumentNode;

/**
 * __useReturnLocalEmailDraft__
 *
 * To run a query within a React component, call `useReturnLocalEmailDraft` and pass it any options that fit your needs.
 * When your component renders, `useReturnLocalEmailDraft` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useReturnLocalEmailDraft({
 *   variables: {
 *      teamId: // value for 'teamId'
 *      instructor: // value for 'instructor'
 *      emailThreadId: // value for 'emailThreadId'
 *   },
 * });
 */
export function useReturnLocalEmailDraft(baseOptions: Apollo.QueryHookOptions<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables> & ({ variables: ReturnLocalEmailDraftVariables; skip?: boolean; } | { skip: boolean; }) ) {
        const options = {...defaultOptions, ...baseOptions}
        return Apollo.useQuery<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>(ReturnLocalEmailDraftDocument, options);
      }
export function useReturnLocalEmailDraftLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>) {
          const options = {...defaultOptions, ...baseOptions}
          return Apollo.useLazyQuery<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>(ReturnLocalEmailDraftDocument, options);
        }
export function useReturnLocalEmailDraftSuspenseQuery(baseOptions?: Apollo.SuspenseQueryHookOptions<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>) {
          const options = {...defaultOptions, ...baseOptions}
          return Apollo.useSuspenseQuery<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>(ReturnLocalEmailDraftDocument, options);
        }
export type ReturnLocalEmailDraftHookResult = ReturnType<typeof useReturnLocalEmailDraft>;
export type ReturnLocalEmailDraftLazyQueryHookResult = ReturnType<typeof useReturnLocalEmailDraftLazyQuery>;
export type ReturnLocalEmailDraftSuspenseQueryHookResult = ReturnType<typeof useReturnLocalEmailDraftSuspenseQuery>;
export type ReturnLocalEmailDraftQueryResult = Apollo.QueryResult<ReturnLocalEmailDraft, ReturnLocalEmailDraftVariables>;