import { css } from '@emotion/css'
import type { CSSProperties, FC } from 'react'

const divider = css`
  margin: 1rem 0;
  border-top: 1px solid rgba(17, 20, 24, 0.15);
  .bp5-dark & {
    border-top-color: rgba(255, 255, 255, 0.2);
  }
`

interface DividerProps {
  style?: CSSProperties
}

const Divider: FC<DividerProps> = ({ style }) => (
  <div className={divider} style={style} />
)

Divider.defaultProps = {
  style: {},
}

export default Divider
