import { useLocalStorageState } from 'ahooks'
import type { NotificationProps } from './typing'

const KEY: string = 'notificationLimit'
const DEFAULT_LIMIT: string = '10'
const notificationLimit = () =>
  Number(localStorage.getItem(KEY) || DEFAULT_LIMIT)

const useNotificationStorage = () =>
  useLocalStorageState<NotificationProps[]>('notifications', {
    defaultValue: [],
    serializer: value => JSON.stringify(value.slice(-notificationLimit())),
    deserializer: localValue =>
      (JSON.parse(localValue) as NotificationProps[]).slice(
        -notificationLimit()
      ),
  })

export default useNotificationStorage
